//Alien-Sensor
//Misst den Abstand zur gegenüber liegenden Wand und gibt passend zum Abstand einen Warnton aus, solange der Taster A am Controller herunter gedrückt wird.
//Ähnlich der Einparkhilfe am Auto.
//Zusätzliches Experiment für Kosmos Kosmobits Experimentierkasten
//Zusätzlich zum Kasten (www.kosmobits.de) wird ein HC-SR04 Ultraschall-Sensor benötigt.
//Weitere Arduino-Projekte für Anfänger auf www.goetzmd.de

#include <KosmoBits_Pins.h>

//Ein- und Ausgangspins definieren
const int buzzerPin = KOSMOBITS_BUZZER_PIN;
const int tasterPin = KOSMOBITS_TASTE_2_PIN;
const int echoPin = 5; //Hier den Sensor Echo-Pin anschließen
const int triggerPin = 6; //Hier den Sensor Trigger-Pin anschließen
//Zusätzlich GND am Sensor mit GND am Kosmoduino
//sowie VCC am Sensor mit 5V am Kosmodoino verbinden!

//Variable für die Messung mit dem Sensor
long sensorWert = 0;

//Variablen für die Zeitmessung
unsigned long zeitAktuell = 0;
unsigned long zeitAlt = 0;

void setup() {
  pinMode(tasterPin, INPUT);
  pinMode(echoPin, INPUT);
  pinMode(triggerPin, OUTPUT);
}

void loop() {
  //Speichert die aktuelle Systemzeit des Arduinos
  zeitAktuell = millis();

  //Löst die Messung des Sensors aus
  digitalWrite(triggerPin, LOW);
  delayMicroseconds(2);
  digitalWrite(triggerPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(triggerPin, LOW);

  //Fragt den gemessenen Wert am Sensor ab, rechnet ihn in einen nutzbaren Bereich um und speichert ihn in der Variable
  sensorWert = ( sqrt(pulseIn(echoPin, HIGH)) * 7 );

  //Wenn die aktuelle Zeit minus der Zeit nach dem letzten Pieps größer ist, als die Sensor-Messung,
  //wird es Zeit für einen neuen Pieps. So werden die Piepser häufiger, je näher wir der Wand kommen.
  if ( (zeitAktuell - zeitAlt) >= (sensorWert) ) {

    //Spielt den kurzen Pieps-Ton
    if (digitalRead(tasterPin) == LOW) {
      tone(buzzerPin, 550);
      delay(20);
      noTone(buzzerPin);
    }

    //Macht ein Backup der aktuelle Zeit
    zeitAlt = zeitAktuell;
    
  }
}
//Wenn du den Code bis hierhin gelesen hast: Respekt!
